{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit Lidentifyfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;

type
  TIDForm = class(TForm)
    Panel1: TPanel;
    PartsListBox: TListBox;
    IDiListBox: TListBox;
    Panel2: TPanel;
    IDListBox: TListBox;
    PointsListBox: TListBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IDiListBoxClick(Sender: TObject);
procedure IDInit;
    procedure PartsListBoxClick(Sender: TObject);
    procedure PointsListBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  IDForm: TIDForm;

implementation
{$R *.DFM}
uses AllShapeLoaderFrm, LoGlobals, LoeditFrm;


procedure TIDForm.FormCreate(Sender: TObject);
begin
  top := identifyfrmY;
  left := identifyfrmX;
end;

procedure TIDForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  PartsListBox.Clear;
  PointsListBox.Clear;
  IDiListBox.Clear;
  IDListBox.Clear;
  identifyfrmY := IDForm.top;
  identifyfrmX := IDForm.left;
  DoSaver;
end;
(***********************************************************)

procedure TIDForm.IDInit;
var
IDCurrentLayer,IDCurrentObj,IDCurrentObjPart,
iiNumparts,iiNumPoints,CountPoints,I:Integer;
Begin
  PartsListBox.Items.Add(' '); PartsListBox.Clear;
  PointsListBox.Items.Add(' '); PointsListBox.Clear;
  IDiListBox.Items.Add(' '); IDiListBox.Clear;
  For I:= 1 to ShapesFound do
    IDiListBox.Items.Add('Obj : '+Inttostr(ShapesFoundArray[I,1])
    +'.'+Inttostr(ShapesFoundArray[I,2])
      +' Type: '  + VoEditForm.ShapeFileTypeRG(LayA[ShapesFoundArray[I,1]{CurrentLayer}].ShpType));
  VoEditForm.DisplayGraphicShape(ShapesFoundArray[1,1],ShapesFoundArray[1,2],0);
  isShapeSelected:=True;
  IDCurrentLayer:=ShapesFoundArray[1,1];
  IDCurrentObj:=ShapesFoundArray[1,2];
  IDCurrentObjPart:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PartsN;
  with IDForm do
  begin
    IDListBox.Clear;
    IDListBox.Items.Add('Layer : '+Inttostr(IDCurrentLayer)
                    +' '+LayA[IDCurrentLayer].Filename);
   IDListBox.Items.Add('Obj : '+Inttostr(IDCurrentObj));
   If ((LayA[IDCurrentLayer].ShpType =3)or(LayA[IDCurrentLayer].ShpType =5)
       or(LayA[IDCurrentLayer].ShpType =13)or(LayA[IDCurrentLayer].ShpType =15)
       or(LayA[IDCurrentLayer].ShpType =23)or(LayA[IDCurrentLayer].ShpType =25)) then
   Begin
     IDListBox.Items.Add('Parts : '+Inttostr(IDCurrentObjPart));
     for iiNumparts := 1 to IDCurrentObjPart do
     begin {Always at least 1 0...}
       iiNumPoints:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PPA[iiNumparts];
       IDListBox.Items.Add('Part '+Inttostr(iiNumparts)
                        +' Points : '+Inttostr(iiNumPoints));
     end;
     CountPoints:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PntsN;
     IDListBox.Items.Add('Total Points : '+Inttostr(CountPoints));
   end;
   IDForm.IDListBox.Items.Add('');
   For I:= 0 to LayA[IDCurrentLayer].AttributesN-1 do
   begin
     IDForm.IDListBox.Items.Add(
     LayA[IDCurrentLayer].AttType[i].Displayname+' : '
            +LayA[IDCurrentLayer].LyrShp[IDCurrentObj].AAttributes[i]);
   end;
 end;
End;

procedure TIDForm.IDiListBoxClick(Sender: TObject);
var
IDCurrentLayer,IDCurrentObj,IDCurrentObjPart,
iiNumparts,iiNumPoints,CountPoints,I:Integer;
begin
  VoEditForm.DisplayGraphicShape(
  ShapesFoundArray[(IDiListBox.ItemIndex+1),1],ShapesFoundArray[(IDiListBox.ItemIndex+1),2],0);
  (*CurrentObj:=ShapesFoundArray[(IDiListBox.ItemIndex+1)];
    CurrentObjPart:=LayA[CurrentLayer].LyrShp[CurrentObj].PartsN;{Numparts}*)
  {  IDListBox.ItemIndex);}
   {);}
  IDCurrentLayer:=ShapesFoundArray[(IDiListBox.ItemIndex+1),1];
  IDCurrentObj:=ShapesFoundArray[(IDiListBox.ItemIndex+1),2];
  IDCurrentObjPart:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PartsN;
  with IDForm do
  begin
    IDListBox.Clear;
    IDListBox.Items.Add('Layer : '+Inttostr(IDCurrentLayer)
              +' '+LayA[IDCurrentLayer].Filename);
    IDListBox.Items.Add('Obj : '+Inttostr(IDCurrentObj));
    If ((LayA[IDCurrentLayer].ShpType =3)or(LayA[IDCurrentLayer].ShpType =5)
       or(LayA[IDCurrentLayer].ShpType =13)or(LayA[IDCurrentLayer].ShpType =15)
       or(LayA[IDCurrentLayer].ShpType =23)or(LayA[IDCurrentLayer].ShpType =25)) then
    Begin
      PartsListBox.Clear;
      IDListBox.Items.Add('Parts : '+Inttostr(IDCurrentObjPart));
      for iiNumparts := 1 to IDCurrentObjPart do
      begin {Always at least 1 0...}
        iiNumPoints:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PPA[iiNumparts];
        IDListBox.Items.Add('Part '+Inttostr(iiNumparts)
                     +' Points : '+Inttostr(iiNumPoints));
        PartsListBox.Items.Add('Part '+Inttostr(iiNumparts)
                         +' Points : '+Inttostr(iiNumPoints));
      end;
      CountPoints:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PntsN;
      IDListBox.Items.Add('Total Points : '+Inttostr(CountPoints));
    end;
    IDForm.IDListBox.Items.Add('');
    For I:= 0 to LayA[IDCurrentLayer].AttributesN-1 do
    begin
      IDForm.IDListBox.Items.Add(
        LayA[IDCurrentLayer].AttType[i].Displayname+' : '
            +LayA[IDCurrentLayer].LyrShp[IDCurrentObj].AAttributes[i]);
    end;
  end;
end;

procedure TIDForm.PartsListBoxClick(Sender: TObject);
var
IDCurrentLayer,IDCurrentObj,IDCurrentObjPart,
iNumPoints,iiNumPoints,ShapeType:Integer;
dXTemp,dYTemp:Double;
begin
  {If in POINT edit mode ?? then       begin}
  PointsListBox.Clear;
  IDCurrentLayer:=ShapesFoundArray[(IDiListBox.ItemIndex+1),1];
  IDCurrentObj:=ShapesFoundArray[(IDiListBox.ItemIndex+1),2];
  IDCurrentObjPart:=PartsListBox.ItemIndex+1;
  ShapeType:= LayA[IDCurrentLayer].ShpType;
  If ((ShapeType = 1)or(ShapeType = 11)or(ShapeType = 21)) then
  Begin{Points}
    dXTemp:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].XMin;
    dYTemp:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].YMin;
    PointsListBox.Items.Add('X: '+Floattostr(dXTemp)
                       +' ,Y: '+Floattostr(dYTemp));
  end else
  begin
    iiNumPoints:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PPA[IDCurrentObjPart];
    for iNumPoints := 1 to iiNumPoints do
    begin {Always at least 1 0...}
      dXTemp:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PARA[IDCurrentObjPart].PA[INumPoints].Xd;
      dYTemp:=LayA[IDCurrentLayer].LyrShp[IDCurrentObj].PARA[IDCurrentObjPart].PA[INumPoints].Yd;
      PointsListBox.Items.Add('X: '+Floattostr(dXTemp)
                         +' ,Y: '+Floattostr(dYTemp));
    end;
  end;
    VoEditForm.DisplayGraphicShape(
               IDCurrentLayer,IDCurrentObj,IDCurrentObjPart);  
end;

procedure TIDForm.PointsListBoxClick(Sender: TObject);
var
  IDCurrentLayer,IDCurrentObj,IDCurrentObjPart,
  IDCurrentObjPoint:Integer;
begin
  IDCurrentLayer:=ShapesFoundArray[(IDiListBox.ItemIndex+1),1];
  IDCurrentObj:=ShapesFoundArray[(IDiListBox.ItemIndex+1),2];
  IDCurrentObjPart:=PartsListBox.ItemIndex+1;
  IDCurrentObjPoint:=PointsListBox.ItemIndex+1;
  {Some new POINT drawing Routine}
  VoEditForm.DisplayEditPoint(IDCurrentLayer,IDCurrentObj,
                   IDCurrentObjPart,IDCurrentObjPoint);
{  Show message(
  Inttostr(IDCurrentLayer)+' , '+
  Inttostr(IDCurrentObj)+' , '+
  Inttostr(IDCurrentObjPart)+' , '+
  Inttostr(IDCurrentObjPoint));}
end;

end.
