{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit Llabelfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Lpropfrm, ComCtrls, ExtCtrls, Gauges;

type
  TLabelPropFrm = class(TForm)
    LabelEdit: TEdit;
    Label1: TLabel;
    Label4: TLabel;
    LabelRotateEdit: TEdit;
    LPOKBtn: TButton;
    LPCancelBtn: TButton;
    LPFontBtn: TButton;
    FontDialog1: TFontDialog;
    TrackBar1: TTrackBar;
    LabelBackgrounded: TCheckBox;
    LabelColorPanel: TPanel;
    HelpBtn: TButton;
    FontLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    
    procedure LPOKBtnClick(Sender: TObject);
procedure InitFromInfo;
    procedure LPFontBtnClick(Sender: TObject);
    procedure LPCancelBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    procedure SetLabelProperties;
  public
    { Public declarations }

  end;

var
  LabelPropFrm: TLabelPropFrm;

implementation

uses  AllShapeLoaderFrm, LoGlobals;

{$R *.DFM}

procedure TLabelPropFrm.FormCreate(Sender: TObject);
begin
  top := labelfrmY;
  left := labelfrmX;
end;

procedure TLabelPropFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  labelfrmY := LabelPropFrm.top;
  labelfrmX := LabelPropFrm.left;
  DoSaver;
end;

procedure TLabelPropFrm.LPOKBtnClick(Sender: TObject);
begin
  SetLabelProperties;
  ModalResult := mrOK;
  Close;
end;
procedure TLabelPropFrm.LPCancelBtnClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TLabelPropFrm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(5000);
end;

procedure TLabelPropFrm.InitFromInfo;
var tempi:Integer;
begin
  LabelEdit.Text:=
    Mapa[CurrentLayer].LyrSym[CurrentObj].SymObjlabelFieldstring;
  tempi:=Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle;
  TrackBar1.Position:=tempi;
  LabelRotateEdit.Text:=IntToStr(tempi);
  LabelBackgrounded.Checked:=
     Mapa[CurrentLayer].LyrSym[CurrentObj].isSymLabelColored;
  LabelColorPanel.Color:=
     Mapa[CurrentLayer].LyrSym[CurrentObj].SymLabelBackColor;
  FontLabel.Font:= Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont;
    {Mapa[ii].LyrSym[ShapeToDo].labelHeight}
End;

procedure TLabelPropFrm.LPFontBtnClick(Sender: TObject);
begin
  FontDialog1.Font:=FontLabel.Font;
  if FontDialog1.Execute then
  begin
    LabelEdit.Font:=FontDialog1.Font;
    FontLabel.Font:=FontDialog1.Font;
  end;
end;

procedure TLabelPropFrm.TrackBar1Change(Sender: TObject);
var tempi:Integer;
begin
   tempi:=TrackBar1.Position;
   Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle:=tempi;
   LabelRotateEdit.Text:=IntToStr(tempi);
   Application.ProcessMessages;
end;

procedure TLabelPropFrm.SetLabelProperties;
var
  alog :LogFont;{ TLogFont;}
  ahFont : hFont;{THandle;}
{  ilfweight: integer;}
{  ilfitalic,ilfunderline,ilfstrikeout:DWORD;}
begin
  Mapa[CurrentLayer].SymLayerLabeled:=4;
  Mapa[CurrentLayer].LyrSym[CurrentObj].isSymLabelSet:=True;
  Mapa[CurrentLayer].LyrSym[CurrentObj].SymObjlabelFieldstring:=
      LabelEdit.Text;
  Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle:=
    StrtoInt(LabelRotateEdit.Text);
   {val(LabelRotateEdit.Text, ftRotation, code); }
  Mapa[CurrentLayer].LyrSym[CurrentObj].isSymLabelColored:=
     LabelBackgrounded.Checked;
  Mapa[CurrentLayer].LyrSym[CurrentObj].SymLabelBackColor:=
    LabelColorPanel.Color;
  Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont:=
    FontLabel.Font;
  Mapa[CurrentLayer].LyrSym[CurrentObj].labelHeight:=
     FontLabel.Font.Height;
{     If fsBold in Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont.Style
     then  ilfweight :=700 else     ilfweight :=300;
     If fsItalic in Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont.Style
     then  ilfitalic :=1 else     ilfitalic :=0;
     If fsUnderline	 in Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont.Style
     then  ilfunderline :=1 else    ilfunderline := 0;
     If fsStrikeout in Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont.Style
     then  ilfstrikeout :=1 else    ilfstrikeout := 0;}
{     setlength(mylfFaceName,length(Mapa[ii].SymFont.Name));}
{mylfFaceName:=Mapa[ii].SymFont.Name;}{'ARIAL';}
{pchar(Mapa[ii].SymFont.Name);}
  GetObject(FontLabel.Font.Handle, SizeOf(alog), @alog);
  alog.lfEscapement:=  (Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle* 10);
{  (Mapa[ii].labelAngle * 10);}
{  if (IsNT) then alog.lfOrientation:=-(Mapa[ii].labelAngle * 10);}
  alog.lfQuality:=PROOF_QUALITY;
  ahfont:=CreateFontIndirect(alog);
(*
  with alog do
  begin
//LOGFONT struct
//you can find all this in win32 help just look under LOGFONT
    lfheight :=Mapa[CurrentLayer].LyrSym[CurrentObj].labelHeight;
    lfFacename := {'MS Sans Serif';}{pchar(Mapa[ii].SymFont.Name);}{mylfFaceName;}'ARIAL';
    lfwidth := abs(lfheight div 2);
    lfEscapement := (Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle * 10);
    lfOrientation := lfescapement;
    lfweight := ilfweight;
    lfitalic := ilfitalic;
    lfunderline := ilfunderline;
    lfstrikeout := ilfstrikeout;
    lfcharset := ANSI_CHARSET;
    lfoutprecision := out_tt_precis;
    lfclipprecision := clip_default_precis;
    lfquality := PROOF_QUALITY;
    lfpitchandfamily := default_pitch or ff_swiss;
  end;
  ahfont := createfontindirect(alog);*)
  FontLabel.Font.handle := ahfont;
  if Mapa[CurrentLayer].LyrSym[CurrentObj].labelAngle >0 then
  begin
    if ahFont <> 0 then
{    Mapa[ii].SymFont.Assign(TFontDialog(Sender).Font)}
   Mapa[CurrentLayer].LyrSym[CurrentObj].SymFont.handle := ahfont;
   end;
end;


end.
