{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LoEditDbFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,Printers,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls,ImgList,   Db,
  StdCtrls, Buttons, ComCtrls, ToolWin;

type
  TVoEditDbForm = class(TForm)
    ToolBar1: TToolBar;
    DBImageList: TImageList;
    AddedOKTB: TToolButton;
    FirstTB: TToolButton;
    PreviousTB: TToolButton;
    NextTB: TToolButton;
    LastTB: TToolButton;
    FindShapeTB: TToolButton;
    PrintTB: TToolButton;
    HelpTB: TToolButton;
    ExitTB: TToolButton;
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Panel2: TPanel;
    ShapeLabel: TLabel;
    ShapeNLabel: TLabel;
    NewDbPanel: TPanel;
    NewNameEdit: TEdit;
    NewSizeEdit: TEdit;
    NewLabel1: TLabel;
    NewLabel2: TLabel;
    NewLabel4: TLabel;
    NewLabel7: TLabel;
    NewTypeCB: TComboBox;
    NewOKBitBtn: TBitBtn;
    NewCancelBitBtn: TBitBtn;
    ConvertPanel: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    ConvertCB: TComboBox;
    MeasuredBtn: TButton;
    ZElevationBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    LinkDbPanel: TPanel;
    LinkDbCB: TComboBox;
    LinkDbEdit: TEdit;
    Label8: TLabel;
    Label5: TLabel;
    LinkDbFile: TSpeedButton;
    LinkDbCancel: TBitBtn;
    LinkDbOK: TBitBtn;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
procedure ClearDatabase;


procedure SetButtons(Way:Boolean);
procedure SetPanels(Which:Integer);
procedure InitDBForm(WhichLayer,Whafor,Shaped:Integer);
    procedure AddedOKTBClick(Sender: TObject);
    procedure FirstTBClick(Sender: TObject);
    procedure PreviousTBClick(Sender: TObject);
    procedure NextTBClick(Sender: TObject);
    procedure LastTBClick(Sender: TObject);
procedure DisplayDbShape(Witch: Integer);
    procedure FindShapeTBClick(Sender: TObject);
    procedure PrintTBClick(Sender: TObject);
    procedure HelpTBClick(Sender: TObject);
    procedure ExitTBClick(Sender: TObject);
    procedure Panel2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NewCancelBitBtnClick(Sender: TObject);
    procedure NewOKBitBtnClick(Sender: TObject);

procedure InitConverter;
    procedure CancelBtnClick(Sender: TObject);
    procedure MeasuredBtnClick(Sender: TObject);
    procedure ZElevationBtnClick(Sender: TObject);

    procedure LinkDbOKClick(Sender: TObject);
    procedure LinkDbCancelClick(Sender: TObject);
    procedure LinkDbFileClick(Sender: TObject);
procedure InitDbLink;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  VoEditDbForm: TVoEditDbForm;

implementation

{$R *.DFM}

uses AllShapeLoaderFrm, LoGlobals, LoeditFrm, LOResMess;

var
  GoingModal:Boolean;
  DbWorkingLayer,DbWorkingShape:Integer;



procedure TVoEditDbForm.FormCreate(Sender: TObject);
begin
  top := VoEditDbfrmY;
  left := VoEditDbfrmX;

  DbWorkingShape := 0;
  DbWorkingLayer:= 0;
  GoingModal:=False;
end;

procedure TVoEditDbForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
If (not GoingModal) then
begin
  If StillOpen then
  begin
   Action	:=caHide;
  end else
  begin
    VoEditDbfrmY := VoEditDbForm.top;
    VoEditDbfrmX := VoEditDbForm.left;
    SetLength(LayDatabase,0);
    Action	:=caFree;
  end;
end;
end;
(*************************************************************)
(*************************************************************)

procedure TVoEditDbForm.ClearDatabase;
Begin
   LayerDBCount := 0;
   SetLength(LayDatabase,0);
End;


(*************************************************************)
(*************************************************************)

(*************************************************************)
procedure TVoEditDbForm.SetButtons(Way:Boolean);
begin
    AddedOKTB.Enabled:=Way;
    ExitTB.Enabled:=Way;
    FirstTB.Enabled:=Way;
    PreviousTB.Enabled:=Way;
    NextTB.Enabled:=Way;
    LastTB.Enabled:=Way;
    FindShapeTB.Enabled:=Way;
    PrintTB.Enabled:=Way;
End;

procedure TVoEditDbForm.SetPanels(Which:Integer);
var HowMany:Integer;
Begin
If Which=1 then
begin {Scrollbar Panel1}
ScrollBox1.Visible:=True;
NewDbPanel.Visible:=False;
ConvertPanel.Visible:=False;
LinkDbPanel.Visible:=False;
LinkDbPanel.Align:=alNone;
If DbWorkingLayer=0 then DbWorkingLayer:=1;
  NewDbPanel.Align:= alNone;
  HowMany:=LayA[DbWorkingLayer].AttributesN;
  VoEditDbForm.Height :=227{+ ((HowMany-2)*45)};
  VoEditDbForm.Width :=216;
  ScrollBox1.Align:=alClient;
  Panel1.Height :=174+ ((HowMany-2)*45);
end;
If Which=2 then
Begin {NewDbPanel}
ScrollBox1.Visible:=False;
NewDbPanel.Visible:=True;
ConvertPanel.Visible:=False;
LinkDbPanel.Visible:=False;
LinkDbPanel.Align:=alNone;
  ScrollBox1.Align:=alNone;
  VoEditDbForm.Height :=227;
  VoEditDbForm.Width :=216;
  NewDbPanel.Align:= alClient;{  Height:=161 Width:=200}
End;
If Which=3 then
Begin {ConvertPanel}
ScrollBox1.Visible:=False;
NewDbPanel.Visible:=False;
LinkDbPanel.Visible:=False;
LinkDbPanel.Align:=alNone;
ConvertPanel.Visible:=True;
  ScrollBox1.Align:=alNone;
  NewDbPanel.Align:=alNone;
  VoEditDbForm.Height :=227;
  VoEditDbForm.Width :=216;
  ConvertPanel.Align:=   alClient;{  Height:=161 Width:=200}
End;
If Which=4 then
Begin {LinkDbPanel}
ScrollBox1.Visible:=False;
NewDbPanel.Visible:=False;
ConvertPanel.Visible:=False;
  ScrollBox1.Align:=alNone;
  NewDbPanel.Align:=alNone;
  ConvertPanel.Align:=alNone;
  VoEditDbForm.Height :=227;
  VoEditDbForm.Width :=216;
LinkDbPanel.Visible:=True;
LinkDbPanel.Align:=alClient;{  Height:=161 Width:=200}
End;
End;
(*************************************************************)
procedure TVoEditDbForm.InitDBForm(WhichLayer,Whafor,Shaped:Integer);
var HowMany, I:Integer;
Begin
{New Shape..input Attributes; Form is ShowModal}
  Case Whafor of
  1:begin
    GoingModal:=True;
    SetButtons(False);
    AddedOKTB.Enabled:=True;
  end;
{Info Shape..view Attributes;
  Select Shape by # to Display on Main form}
  2:begin
    SetButtons(True);
    AddedOKTB.Enabled:=False;
    GoingModal:=False;
  end;
  end;{Case}
  {Edit Shape Attributes... all above-not showmodal}
  ShapeNLabel.Caption:=IntToStr(Shaped);
  DbWorkingShape:=Shaped;

If DbWorkingLayer<>WhichLayer then
begin
  SetPanels(1);
{  for I := 0 to Panel1.ComponentCount - 1 do}
  for I := Panel1.ComponentCount - 1 downto 0 do
  begin
    Panel1.Components[I].Free;
  end;

  DbWorkingLayer:=WhichLayer;
  HowMany:=LayA[WhichLayer].AttributesN;

  VoEditDbForm.Height :=227{+ ((HowMany-2)*45)};
  VoEditDbForm.Width :=216;
  Panel1.Height :=174+ ((HowMany-2)*45);

  For I:=1 to HowMany do
  Begin
      with TEdit.Create(Panel1{Self}) do
      begin
        Parent := Panel1;
        Name:='Edit'+IntToStr(I);
        Font:=ShapeLabel.Font;
        Left := 18;
        Top := 32+ ((I-1)*45);
        Text:=LayA[WhichLayer].LyrShp[Shaped].AAttributes[i-1];
      end;
      with TLabel.Create(Panel1{Self}) do
      begin
        Parent := Panel1;
        Name:='Label'+IntToStr(I);
        Font:=ShapeLabel.Font;
        Width:= 175;
        Left := 6;
        Top := 16+ ((I-1)*45);
        Alignment:= taCenter;
        Caption:= LayA[WhichLayer].AttType[i-1].Displayname;
      end;
  End;
end;{activated}
 DisplayDbShape(DbWorkingShape);
End;
(*************************************************************)
(*************************************************************)

(*************************************************************)
{Activates Database Editing capability}
{TMouseButton = (mbLeft, mbRight, mbMiddle);
TShiftState = set of
(ssShift, ssAlt, ssCtrl,
 ssLeft, ssRight, ssMiddle, ssDouble); }
procedure TVoEditDbForm.Panel2MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ((Button = mbRight) and (Shift = [ssCtrl])) then
  begin
    AddedOKTB.Enabled:=True;
  end;
end;
(*************************************************************)
procedure TVoEditDbForm.ExitTBClick(Sender: TObject);
begin
  Close;
end;

  {process the Edits into the Attributes
  WorkingShape}
procedure TVoEditDbForm.AddedOKTBClick(Sender: TObject);
var
  Counter, I:Integer;
  Temp: TEdit;
begin
  Counter:=-1;
  for I := 0 to Panel1.ComponentCount - 1 do
  begin
    if (Panel1.Components[I] is TEdit) then
    begin
    inc(Counter);
      Temp := Panel1.Components[I]as TEdit;
      {Panel1.Components[I]}
      LayA[DbWorkingLayer].LyrShp[DbWorkingShape].AAttributes[Counter]:=
      Temp.Text;
    end;
  end;
  If GoingModal then {Allows multiple changes during Edit}
  begin
  GoingModal:=False;
  Close;   {Only 1 Change the NEW Shape}
  end;
end;

procedure TVoEditDbForm.FirstTBClick(Sender: TObject);

begin
   DbWorkingShape:=1;
   DisplayDbShape(DbWorkingShape);
end;

procedure TVoEditDbForm.PreviousTBClick(Sender: TObject);

begin
   If (DbWorkingShape>1) then
   begin
   dec(DbWorkingShape);
   DisplayDbShape(DbWorkingShape);
   end;
end;

procedure TVoEditDbForm.NextTBClick(Sender: TObject);

begin
   inc(DbWorkingShape);
   If (DbWorkingShape< LayA[DbWorkingLayer].ShapeN) then
   begin
   DisplayDbShape(DbWorkingShape);
   end else dec(DbWorkingShape);
end;

procedure TVoEditDbForm.LastTBClick(Sender: TObject);
begin
   DbWorkingShape:=LayA[DbWorkingLayer].ShapeN-1;
   DisplayDbShape(DbWorkingShape);
end;

procedure TVoEditDbForm.DisplayDbShape(Witch: Integer);
var
  Counter, I:Integer;
  Temp: TEdit;
begin
    {WorkingShape}
{  HowMany:=LayA[WorkingLayer].AttributesN;}
  ShapeNLabel.Caption:=IntToStr(Witch);
  Counter:=-1;
  for I := 0 to Panel1.ComponentCount - 1 do
  begin
    if (Panel1.Components[I] is TEdit) then
    begin
    inc(Counter);
      Temp := Panel1.Components[I]as TEdit;
      Temp.Text:=
      LayA[DbWorkingLayer].LyrShp[Witch].AAttributes[Counter];
    end;
  end;
end;

procedure TVoEditDbForm.FindShapeTBClick(Sender: TObject);
begin
    VoEditForm.DisplayGraphicShape(DbWorkingLayer,DbWorkingShape,0);
end;

procedure TVoEditDbForm.PrintTBClick(Sender: TObject);
var
  Counter,Iii, Ii, I, Stop, Pages:Integer;
  Answer:Word;
  PrintText: TextFile;   {declares a file variable}
begin
    {1 or All (pages)}
  Pages:=(((3+LayA[DbWorkingLayer].AttributesN)
    *LayA[DbWorkingLayer].ShapeN)
     div 50);{Computed # of pages}
  Answer:= DoRezConfirmYAC(1,Pages);
  AssignPrn(PrintText);   {assigns PrintText to the printer}
  Rewrite(PrintText);     {creates and opens the output file}
  Printer.Canvas.Font := Panel1.Font;  {assigns Font settings to the canvas}
  with Printer do
  begin
      Title:=LayA[DbWorkingLayer].LayerDBName;
      Printer.Orientation := poPortrait;
  end;
  If (Answer = mrOk)then
  begin      {1  (pages)}
    For i:= 0 to 3 do Writeln(PrintText, '');
    Writeln(PrintText, '        '+LayA[DbWorkingLayer].LayerDBName);
    Writeln(PrintText, '');
    Writeln(PrintText, '');
    For Counter:= 0 to LayA[DbWorkingLayer].AttributesN-1 do
    Writeln(PrintText, '        '+
      'Shape# '+Inttostr(DbWorkingShape)+'  '+
      'Attribute '+LayA[DbWorkingLayer].AttType[Counter].Displayname+' : '+
      LayA[DbWorkingLayer].LyrShp[DbWorkingShape].AAttributes[Counter]);
    Writeln(PrintText, #13#10);
  end
  else
  If (Answer = mrAll)then
  begin        {All (pages)}
      Ii:=0;
      Iii:=0;
      Stop:=(45 div(3+LayA[DbWorkingLayer].AttributesN));
      for I := 1 to LayA[DbWorkingLayer].ShapeN do
      begin
        inc(Ii);
    Writeln(PrintText, '');
    Writeln(PrintText, '');
    For Counter:= 0 to LayA[DbWorkingLayer].AttributesN-1 do
    Writeln(PrintText, LayA[DbWorkingLayer].LyrShp[I].AAttributes[Counter]);
        if Ii = Stop then
        begin
        Ii:=0;
        inc(Iii);
        Writeln(PrintText, '');
        Writeln(PrintText, '                  Page # '
                +Inttostr(Iii)
                +' of '
                +LayA[DbWorkingLayer].LayerDBName);{Page# of #}
        Writeln(PrintText, #13#10);
        end;
      end;
      Writeln(PrintText, #13#10);
  end;
      CloseFile(PrintText); {Closes the printer variable}
end;

procedure TVoEditDbForm.HelpTBClick(Sender: TObject);
begin
    Application.HelpContext(6000);
end;


procedure TVoEditDbForm.NewCancelBitBtnClick(Sender: TObject);
begin
  SetPanels(1);
  SetButtons(True);
end;

procedure TVoEditDbForm.NewOKBitBtnClick(Sender: TObject);
var I,Which:Integer;
TempString:String;
begin
{make a new field.. Process the data}
  Which:=LayA[DbWorkingLayer].AttributesN;
  inc(Which);
  LayA[DbWorkingLayer].AttributesN:=Which;
  SetLength(LayA[DbWorkingLayer].AttType, Which);
  LayA[DbWorkingLayer].AttType[Which].FieldNo:= Which;
  TempString:=NewNameEdit.Text;
  If TempString='' then TempString:='Newbie';
  If Length(TempString)>25 then Delete(TempString,25,255);
  LayA[DbWorkingLayer].AttType[Which].Displayname:=
      TempString;
  Case NewTypeCB.ItemIndex of
  0:  LayA[DbWorkingLayer].AttType[Which].DataType:=
      ftString;
     { String Integer  Float	 Boolean DateTime Currency}
  1:   LayA[DbWorkingLayer].AttType[Which].DataType:=
      ftInteger;
  End;{Case}
  If NewTypeCB.ItemIndex=0 then
  begin
  TempString:=NewSizeEdit.Text;
  If TempString='' then TempString:='0';
  end else TempString:='0';
  LayA[DbWorkingLayer].AttType[Which].Size:=
      StrToInt(TempString);
  LayA[DbWorkingLayer].AttType[Which].Precision:=
      LayA[DbWorkingLayer].AttType[Which-1].Precision;
  LayA[DbWorkingLayer].AttType[Which].Required:=
      LayA[DbWorkingLayer].AttType[Which-1].Required;
  For I:= 1 to LayA[DbWorkingLayer].ShapeN do
  begin
    SetLength(LayA[DbWorkingLayer].LyrShp[I].AAttributes,
           LayA[DbWorkingLayer].AttributesN);
    Case NewTypeCB.ItemIndex of
       0..2:TempString:='0';
       3:TempString:='False';
       4:TempString:=DateTimeToStr(Now);
       5:TempString:='0.0';
       end;{Case}
    LayA[DbWorkingLayer].LyrShp[I].AAttributes[Which]:=TempString;
  end;
  DbWorkingLayer:=0;
  VoEditDbForm.Close;
end;
(*************************************************************)
(*************************************************************)
procedure TVoEditDbForm.Panel1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{Not allowed while Adding Data}
  If ( (not GoingModal) and
     (Button = mbRight) and (Shift = [ssCtrl])) then
  begin
{All Buttons Disabled}
    SetButtons(False);
    SetPanels(2);{Add a Field}
  end;
  If ( (not GoingModal) and
     (Button = mbRight) and (Shift = [ssAlt])) then
  begin
{All Buttons Disabled}
    SetButtons(False);
    SetPanels(3);
    InitConverter;
  end;
  If ( (not GoingModal) and
     (Button = mbRight) and (Shift = [ssShift])) then
  begin
{All Buttons Disabled}
    SetButtons(False);
    SetPanels(4);
    InitDbLink;
  end;
end;
(*************************************************************)
(*************************************************************)
procedure TVoEditDbForm.InitConverter;
{Fill ConvertCB}
var
  i: integer;
begin
  ConvertCB.Items.Clear;
  for i := 0 to LayA[CurrentLayer].AttributesN-1  do
  begin
    ConvertCB.Items.Add(LayA[CurrentLayer].AttType[i].Displayname);
  end;
  ConvertCB.ItemIndex := 0;
End;

procedure TVoEditDbForm.CancelBtnClick(Sender: TObject);
begin
  SetPanels(1);
  SetButtons(True);
end;


{type TFieldType =
(ftUnknown, ftString, ftSmallint, ftInteger, ftWord, ftBoolean,
ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic,
ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor,
ftFixedChar, ftWideString, ftLargeint, ftADT, ftArray,
 ftReference, ftDataSet, ftOraBlob, ftOraClob, ftVariant,
 ftInterface, ftIDispatch, ftGuid);}
 { String Integer  Float	 Boolean DateTime Currency}

procedure TVoEditDbForm.MeasuredBtnClick(Sender: TObject);
begin {Any number type}
 { String Integer  Float	 Boolean DateTime Currency}
If
(LayA[CurrentLayer].AttType[ConvertCB.ItemIndex].DataType= ftInteger)
or
(LayA[CurrentLayer].AttType[ConvertCB.ItemIndex].DataType= ftFloat)
then
begin
{Copy all the data into .Md
then copy the other attributes and Setlength 1 less
set AttributeN -1
LayA[CurrentLayer].AttType[i].Displayname);}
end;
end;

procedure TVoEditDbForm.ZElevationBtnClick(Sender: TObject);
begin {Only Integer or Float}
If
(LayA[CurrentLayer].AttType[ConvertCB.ItemIndex].DataType= ftInteger)
or
(LayA[CurrentLayer].AttType[ConvertCB.ItemIndex].DataType= ftFloat)
then
begin
{LayA[CurrentLayer].ShpType:=}
{LayA[CurrentLayer].AttType[i].Displayname);}
end;
end;
(*************************************************************)
(*************************************************************)
procedure TVoEditDbForm.LinkDbCancelClick(Sender: TObject);
begin
  SetPanels(1);
  SetButtons(True);
end;

procedure TVoEditDbForm.LinkDbFileClick(Sender: TObject);
begin
  OpenDialog.InitialDir := VRMDatabase;
  OpenDialog.Filter := 'Shape File Maps(*.shp, *.map)|*.shp;*.map';
  if OpenDialog.Execute then
  begin
    if length(OpenDialog.filename) = 0 then Exit;
      If FileExists(ChangeFileExt(OpenDialog.Filename,'.dbf')) then
      begin
       VRMDatabase := ExtractFilePath(OpenDialog.Filename);
       LinkDbEdit.Text:=ExtractFileName(OpenDialog.Filename);
       bNDatabaseActive := True;
      end else DoRezError(20);
  end;
end;

procedure TVoEditDbForm.InitDbLink;
var
  i: integer;
begin
  LinkDbCB.Items.Clear;
  for i := 0 to LayA[CurrentLayer].AttributesN-1  do
  begin
    LinkDbCB.Items.Add(LayA[CurrentLayer].AttType[i].Displayname);
  end;
  LinkDbCB.ItemIndex := 0;
End;

procedure TVoEditDbForm.LinkDbOKClick(Sender: TObject);
begin
SearchDbField:=LinkDbCB.ItemIndex;
bNDatabaseActive:=True;
{LinkDbFile ?FIELD?
to
 LinkDbCB.ItemIndex Field ala Soils Db?}
end;



end.
